/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_VIATURA                                                  */
/* Tabela : VIATURA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 26/10/2004 - WELBERT G.MOITINHA                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_VIATURA
BEFORE INSERT OR UPDATE OR DELETE
ON VIATURA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUVIAT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (:OLD.CDVIATURA  <> :NEW.CDVIATURA ) OR
         (:OLD.NRPLACA    <> :NEW.NRPLACA  )     OR
         (:OLD.DSTIPOVEIC <> :NEW.DSTIPOVEIC) THEN
         :NEW.DTULTATUVIAT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('VIATURA', '', 'CDVIATURA='||:OLD.CDVIATURA||';', SYSDATE);
   END IF;
END;
/
ALTER TABLE VIATURA MODIFY DTULTATUVIAT DEFAULT SYSDATE
/
