create or replace TRIGGER LOG_GOP_PRODUTOROP
AFTER INSERT
ON PRODUTOROP FOR EACH ROW
DECLARE
  V_TIPO                VARCHAR2(1);
  V_DSREMOTEADDR        VARCHAR2(15);
  V_DSREMOTEHOST        VARCHAR2(15);
  V_DSSERVERRDM         VARCHAR2(100);
  V_DSSERVMETHOD        VARCHAR2(4000);
  V_DSREMOTEOPER        VARCHAR2(12);
  V_DESC                VARCHAR2(500);
  V_DESCUPD             VARCHAR2(200);
  V_CDFILLOGOPER        VARCHAR2(4);
  V_ITPESQ              VARCHAR2(40);
  V_NMOPERADOR          VARCHAR2(40);
  V_CDOPERADOR          VARCHAR2(12);
  V_CDFILIAL            VARCHAR2(20);
  V_NMFILIAL            VARCHAR2(50);
  V_NMPRODUTO           VARCHAR2(100);
  V_CDARVPROD           VARCHAR2(100);
  V_UNIDADE             VARCHAR2(50);

BEGIN
/* IDTIPOOPER - '1' - Inclusao, '2' - Alteracao, '3' - Exclusao*/
   V_TIPO         := '0';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_DESCUPD      := '';
   V_CDOPERADOR   := :NEW.CDOPERULTATU;
   V_CDFILLOGOPER := '';

   NMOPERADOR(V_CDOPERADOR, V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

    V_DSSERVERRDM := 'gop00100_parametros_resultado_operacional';
    V_DESCUPD := 'Parametros pra Resultado Operacional' || chr(10) || '-> ';

    IF INSERTING THEN

        V_TIPO         := '1';
        V_ITPESQ       := TO_CHAR(:NEW.CDFILIAL) || '|' || TO_CHAR(:NEW.CDPRODUTO);


        IF TO_CHAR(:NEW.CDFILIAL) = 'T' OR TO_CHAR(:NEW.CDFILIAL) =  'P' THEN
            V_UNIDADE   := 'Unidade: Padrao' || chr(10);
        ELSE
            SELECT MAX(CDFILIAL), MAX(NMFILIAL) INTO V_CDFILIAL, V_NMFILIAL FROM FILIAL WHERE CDFILIAL = :NEW.CDFILIAL;
            V_UNIDADE   := 'Unidade: '|| V_CDFILIAL || ' - ' || V_NMFILIAL || chr(10);
        END IF;


        SELECT MAX(CDARVPROD), MAX(NMPRODUTO) INTO V_CDARVPROD, V_NMPRODUTO FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;

        IF :NEW.IDTPPRODUTOROP = 'DE' THEN
            V_DESCUPD := V_DESCUPD || 'Despesa -> Lancamentos de Entrada -> Despesa -> Nivel Produto';

        ELSIF :NEW.IDTPPRODUTOROP = 'EX' THEN
            V_DESCUPD := V_DESCUPD || 'Despesa -> Lancamentos de Entrada -> Despesa -> Excecoes';

        ELSIF :NEW.IDTPPRODUTOROP = 'MO' THEN
            V_DESCUPD := V_DESCUPD || 'Despesa -> Lancamentos de Entrada ->  Mao de Obra -> Nivel Produto';

        ELSIF :NEW.IDTPPRODUTOROP = 'MX' THEN
            V_DESCUPD := V_DESCUPD || 'Despesa -> Lancamentos de Entrada ->  Mao de Obra -> Excecoes';

        END IF;
        
        IF :NEW.IDTPPRODUTOROP IS NOT NULL THEN 
           V_DESC := 'Produto: ' ||  V_CDARVPROD || ' - ' || V_NMPRODUTO;
        END IF;

    END IF;
    IF NOT V_DESC IS NULL THEN
      V_DESC := V_DESCUPD || chr(10) || chr(10) || V_UNIDADE || V_DESC;
      INSERT INTO LOGOPERAGES
        (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO,  CDPESQITEM,
         DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
      VALUES
        ('PRODUTOROP', SYSDATE, NVL(V_NMOPERADOR,' '), V_TIPO, V_DESC, V_ITPESQ, NVL(V_DSSERVERRDM, ' '), 
          NVL(V_DSREMOTEADDR, ' '), NVL(V_DSREMOTEHOST, ' '), NVL(V_DSSERVMETHOD, ' '), NVL(V_CDOPERADOR, ' '),
          NVL(V_CDFILLOGOPER, ' '));
    END IF;
END;