var dfs11000_LancamentoSaida_Service = function(localStorageEngine, Dfs11000_LancamentoSaida_Repositories, ZHPromise, General) {

    this.salvaVencimento = function(vencimento) {
        return Dfs11000_LancamentoSaida_Repositories.salvaVencimento(vencimento);
    };

    this.excluiVencimento = function(vencimento){
        return Dfs11000_LancamentoSaida_Repositories.excluiVencimento(vencimento);
    };

    this.excluirNota = function(consultaLancamentoRow) {
        return Dfs11000_LancamentoSaida_Repositories.excluirNota(consultaLancamentoRow.CDFILIAL, consultaLancamentoRow.NRLANCTONF);
    };

    var getDataSourceVencimento = function() {
        return localStorageEngine.getDataSource("df#/lancamento_nota_vencimento").then(function(vencimento){
            return vencimento;
        });
    };
    
    this.getFilial = function(){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
        ];
        return General.callRestEngine("df#/crud/filial", "FilterData", filter);
    };

    this.getProxSeqVencimento = function(){
        return setMaxSequencialVencimento().then(function(maxSeqVencimento){
            var proxSeqVencimento = parseInt(maxSeqVencimento) + 1;
            var str = "" + proxSeqVencimento;
            
            var pad = "00";
            return pad.substring(0, pad.length - str.length) + str;
        });
    };

    var setMaxSequencialVencimento = function() {
        return getDataSourceVencimento().then(function(vencimentos){
            var maxSeqVencimento = '00';
            vencimentos.forEach(function(vencimento){
                if(parseInt(vencimento.NRSEQVENREC) > parseInt(maxSeqVencimento))
                    maxSeqVencimento = vencimento.NRSEQVENREC;
            });
            return maxSeqVencimento;
        });
    };

    this.retornaClienteFilial = function(filial, cliente) {
        return Dfs11000_LancamentoSaida_Repositories.retornaClienteFilial(filial, cliente);
    };
    
    //----------------------------------- DFS11300 Replicação de Documentos ---------------------------------------------------//
    
    /**
     * Replica o documento através de chamada
     * do backend.
     * 
     * @param {object} widget
     * 
     * return {promisse}
     */
    this.replicarDocumento = function(dataset) {
        return General.callRestEngine('df#/replicacaoManual', 'DataSet', dataset);
    };
    
    this.copiarNF = function(row){
      return  General.callRestEngine('df_saida#/copiarNF', 'Row', row);
    };
    
    this.saveDataUpdate = function (rowsUpdate, NEWDTENTRSAID) {
        return Dfs11000_LancamentoSaida_Repositories.saveDataUpdate(rowsUpdate, NEWDTENTRSAID);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfs11000_LancamentoSaida_Service", dfs11000_LancamentoSaida_Service);
});